//
//  LWFadeWindow.m
//
//  Copyright (c) 2004 David McGavern, Loopware. All rights reserved.
//
//  Simply fades the window in and out when opened/closed :-)
//  The implementation probably could be better... but hey!
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.
//

#import "LWFadeWindow.h"


@implementation LWFadeWindow

- (void)close{
    if ([[NSUserDefaults standardUserDefaults] boolForKey:@"fadingWindows"]){
        if ([self alphaValue]>=1){
            timerAlphaValue=1;
            fadeTimer=[NSTimer scheduledTimerWithTimeInterval:.01 target:self selector:@selector(fadeTimerFired:) userInfo:nil repeats:YES];
        }
    } else {
        [super close];
    }
}
- (void)fadeTimerFired:(NSTimer *)aTimer{
    timerAlphaValue-=.1;
    [self setAlphaValue:timerAlphaValue];
    if (timerAlphaValue<0){
	fadeTimer=nil;
        [aTimer invalidate];
        [super close];
    }
}
- (void)orderFrontRegardless{
    [super orderFrontRegardless];
    [self setAlphaValue:1];
}
- (void)fadeInTimerFired:(NSTimer *)aTimer{
    timerAlphaValue+=.15;
    [self setAlphaValue:timerAlphaValue];
    if (timerAlphaValue>1){
        [aTimer invalidate];
	fadeTimer=nil;
    }
}
- (void)makeKeyAndOrderFront:(id)sender{
    if (([[NSUserDefaults standardUserDefaults] boolForKey:@"fadingWindows"] && !launched) || [self alphaValue]<1){
        //[self setAlphaValue:0];
        [super makeKeyAndOrderFront:sender];
        timerAlphaValue=[self alphaValue];
        launched=YES;
	if (fadeTimer) [fadeTimer invalidate];
	
        fadeTimer=[NSTimer scheduledTimerWithTimeInterval:.01 target:self selector:@selector(fadeInTimerFired:) userInfo:nil repeats:YES];
    } else {
	if (fadeTimer) [fadeTimer invalidate];
        [super makeKeyAndOrderFront:sender];
    }
}

- (void)dealloc{     
    [super dealloc];
}

@end
