//
//  NSStringCategory.m
//  UTModLauncher
//
//  Created by David McGavern on Mon Oct 27 2003.
//  Copyright (c) 2004 David McGavern, Loopware. All rights reserved.
//
//  Some NSString additions that I found missing... so I put them in myself :-)
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.
//

#import "NSStringCategory.h"

#import <CURLHandle/CURLHandle.h>
#import <CURLHandle/CURLHandle+extras.h>

@implementation NSString (NSStringCategory)
+ (NSString *)stringByReplacing:(NSString *)whatGoes with:(NSString *)whatComes inString:(NSString *)aString{
    NSMutableString *string=[NSMutableString stringWithString:aString];
    while ([string rangeOfString:whatGoes options:NSCaseInsensitiveSearch].length>0){
	[string replaceCharactersInRange:[string rangeOfString:whatGoes options:NSCaseInsensitiveSearch] withString:whatComes];
    }
    
    return [NSString stringWithString:string];
}

- (NSString *)stringByAddingPercentEscapes{
    return [(NSString*)CFURLCreateStringByAddingPercentEscapes(NULL, (CFStringRef)self, NULL, NULL, kCFStringEncodingUTF8) autorelease];
}

+ (NSString *)stringByDeletingLeadSpaceInString:(NSString *)aString{
    NSString *tempWord=[NSString stringWithString:aString];
    
    if ([tempWord length]>0){
	while ([tempWord characterAtIndex:0]==' '){
	    tempWord=[tempWord substringWithRange:NSMakeRange(1, [tempWord length]-1)];
	    if ([tempWord length]==0) return @"";
	}
    }
    
    return tempWord;
}

@end
